summaryrefslogtreecommitdiff
path: root/tests/mv/no-target-dir
diff options
context:
space:
mode:
Diffstat (limited to 'tests/mv/no-target-dir')
-rwxr-xr-xtests/mv/no-target-dir70
1 files changed, 70 insertions, 0 deletions
diff --git a/tests/mv/no-target-dir b/tests/mv/no-target-dir
new file mode 100755
index 0000000..db7fe94
--- /dev/null
+++ b/tests/mv/no-target-dir
@@ -0,0 +1,70 @@
+#!/bin/sh
+# ensure that --no-target-directory (-T) works when the destination is
+# an empty directory.
+
+# Copyright (C) 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ mv --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir -p d/sub empty src d2/sub e2 || framework_failure=1
+touch f || framework_failure=1
+
+# Skip this test if there's an underlying kernel bug.
+mkdir a b b/a || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+mv a b || {
+ echo "$0: skipping this test: your kernel's rename syscall is buggy" 1>&2
+ (exit 77); exit 77
+}
+
+fail=0
+
+# This should succeed, since both src and dest are directories,
+# and the dest dir is empty.
+mv -fT d empty || fail=1
+
+# Ensure that the source, d, is gone.
+ls -d d > /dev/null 2>&1 && fail=1
+
+# Ensure that the dest dir now has a subdirectory.
+test -d empty/sub || fail=1
+
+
+# rename must fail, since the dest is non-empty.
+mv -fT src d2 2> /dev/null && fail=1
+
+# rename must fail, since the src is not a directory.
+mv -fT f e2 2> /dev/null && fail=1
+
+(exit $fail); exit $fail